#include<stdio.h>
#include<stdlib.h>
#include<string.h>

char * commands [27]={"!CLRS","!AT","!TCLR","!BCLR","!NOTON","!VVAL","!NOTE","!LENV","!FORM","!USRT",
"!CDEF","!GR","!CLRG","!ORD","!LI","!PPOS","!GETPRINT","!SQRCLR","!SPOS","!SDEF","!IFCLOSE","!EXPAND",
"!WAITFOR","!DPOKE","!MPOKE","!STOPON","!RESTORETO"} ;
unsigned char cmps [27]={0X8C,0XD6,0X44,0X20,0XE2,0X71,0X96,0XDD,0X50,0XC3,0X1C,0XE0,0X80,0XA5,0XE1,0X59,
0XDC,0X11,0X5F,0X3C,0XB7,0X2A,0XA6,0X1F,0X31,0XB2,0XBD} ;

int getcmp(int m) {
    int q;
    for (q=0; q<=26; q++)
        if (cmps[q]==m) return q;
    return -1;
}
unsigned char outbuf [256];
unsigned short linepos,linenum;
FILE * out;
void line(unsigned short num, char * text) {
   linenum=num;
   sprintf(outbuf,text);
   linepos+= strlen(outbuf)+1;
   fwrite(&linepos,2,1,out);
   fwrite(&linenum,2,1,out);
   fwrite(outbuf,strlen(outbuf)+1,1,out);

}
void main(int argc, char** argv) {
   int dataln;
   unsigned char cmd [256], app[32];
   if (argc !=3) {
      printf("Usage: makedata from.prg to.prg\n");
   }
   FILE *f = fopen(argv[1], "rb");
   out = fopen(argv[2], "wb");
   outbuf[0]=1;
   outbuf[1]=8;
   linepos=0x801;
   fwrite(outbuf,2,1,out);
   fseek(f, 0, SEEK_END);
   long fsize = ftell(f);
   fseek(f, 2, SEEK_SET);  /* same as rewind(f); */
   unsigned char *buff = malloc(fsize + 1);
   fread(buff, fsize-2, 1, f);
   fclose(f);
   line(1000,"SS\xb2 49152");
// printf("1000 SS=49152");
   line(1010,"\x8d 60000");
//   printf("\n1010 GOSUB 60000");
   line(1020,"SH\xb2\xb5(SS\xad 256):SL\xb2SS\xabSH\xac 256:EH\xb2\xb5(AA\xad 256):EL\xb2 AA\xab EH\xac 256");

//   printf("\n1020 SH=INT(SS/256):SL=SS-SH*256:EH=INT(AA/256):EL=AA-EH*256");
   line(1030,"\x9e 57812(\"EXBAS\"),8,1:\x97 193,SL:\x97 194,SH");

//   printf("\n1030 SYS 57812(\"exbas\"),8,1:POKE 193,SL:POKE 194,SH");
   line(1040,"\x97 174,EL:\x97 175,EH");

//   printf("\n1040 POKE 174,EL:POKE 175,EH");
   line(1050,"\x9e 62957");

//   printf("\n1050 SYS 62957");
   line(1060,"\x80");
//   printf("\n1060 END ");
   dataln=60000;
   int i,cm,su,pp,grp;
   unsigned char b;
   line(dataln,"AA\xb2SS");
//   printf("\n%d AA=SS",dataln);

   dataln+=10;
   line(dataln,"SU\xb2 1000");
//   printf("\n%d SU=1000",dataln);

   dataln+=10;
   line(dataln,"\x87 BB");
//   printf("\n%d READ BB",dataln);

   dataln+=10;
   line(dataln,"\x8B BB\xb2 1000 \xa7 \x8e");
//   printf("\n%d IF BB=1000 THEN RETURN",dataln);

   dataln+=10;
   sprintf(cmd,"\x8B BB\xb3 256 \xa7 \x89 %d",dataln+30);
   line(dataln,cmd);
//   printf("\n%d IF BB<256 THEN GOTO %d",dataln,dataln+30);

   dataln+=10;
   line(dataln,"\x8B BB\xb3\xb1SU \xa7 \x99\"ERROR NEAR DATA LINE \"; \xc2 (63)\xaa 256 \xac \xc2 (64)");
//   printf("\n%d IF BB<>SU THEN PRINT \"error near data line \"; PEEK(63)+256*PEEK(64) ",dataln);

   dataln+=10;
   sprintf(cmd,"\x89 %d",dataln-50);
   line(dataln,cmd);

//   printf("\n%d GOTO %d",dataln,dataln-50);

   dataln+=10;
   line(dataln,"\x97 AA,BB");
//   printf("\n%d POKE AA,BB",dataln);

   dataln+=10;
   line(dataln,"SU\xb2SU\xaa BB");
//   printf("\n%d SU=SU+BB",dataln);

   dataln+=10;
   line(dataln,"AA\xb2 AA\xaa 1");
//   printf("\n%d AA=AA+1",dataln);

   dataln+=10;
   sprintf(cmd,"\x89 %d",dataln-80);
   line(dataln,cmd);
// printf("\n%d GOTO %d",dataln,dataln-80);

   dataln+=10;
   line(dataln,"\x8f START PART");
//   printf("\n%d REM start part",dataln);

   su=1000;
   for (i=0,grp=0;i<fsize-2;i++,grp++) {
      b=buff[i];
      cm=1;
      pp=getcmp(buff[i+1]);
      if (b==201 && (pp != -1) && buff[i+2]==0xD0 && buff[i+3]<0x80) {
         sprintf(app,",%d",su);
         strcat(cmd,app);
         line(dataln,cmd);
//         printf(",%d",su);
         dataln /= 100;
         dataln+=1;
         dataln *= 100;
         su=1000;
         grp=0;
         sprintf(cmd,"\x8f %s",commands[pp]);
//       printf("\n%d REM %s",dataln,commands[pp]);
         if (grp % 8 !=0) {
            dataln+=5;
            sprintf(cmd,"\x83 %d",b);
//            printf("\n%d DATA %d",dataln,b);
            su+=b;
            cm=0;
         }
      }

      if (i==fsize-5) {
         sprintf(app,",%d",su);
         strcat(cmd,app);
         line(dataln,cmd);

//         printf(",%d",su);
         dataln = 64000;
         su=1000;
         sprintf(cmd,"\x8F FINAL PART");
//         printf("\n%d REM final part",dataln);
         if (grp % 8 !=0) {
            line(dataln,cmd);
            dataln+=5;
            sprintf(cmd,"\x83 %d",b);
//            line(dataln,cmd);
//            printf("\n%d DATA %d",dataln,b);
            su+=b;
            cm=0;
         }
      }


      if (grp % 8 == 0) {
         line(dataln,cmd);
         dataln+=5;
         sprintf(cmd,"\x83 %d",b);

//         printf("\n%d DATA %d",dataln,b);
         cm=0;
         su+=b;
      }
      if (cm) {
         su+=b;
         sprintf(app,",%d",b);
         strcat(cmd,app);
//         printf(",%d",b);

      }
   }
//   printf(",%d",su);
   sprintf(app,",%d",su);
   strcat(cmd,app);
   line(dataln,cmd);
   su=1000;
   dataln+=10;
   line(dataln,"\x83 1000");
//   printf("\n%d DATA 1000",dataln);
   dataln+=10;
   line(dataln,"\x80");
//   printf("\n%d END",dataln);
   outbuf[0]=0;
   outbuf[1]=0;
   outbuf[2]=0;
   fwrite(outbuf,3,1,out);

   fclose(out);
}